#include <stdio.h>
#include <gtk/gtk.h>

struct bmp_header {
  guint32  filesize;
  guint32  reserved1;
  guint32  data_offset;
  guint32  header_size;
  guint32  width;
  guint32  height;
  guint16  planes;
  guint16  bpp;
  guint32  comp;
  guint32  data_size;
  guint32  H_Resolution;
  guint32  V_Resolution;
  guint32  color_num;
  guint32  imp_col_num;
};
typedef struct bmp_header BMPHeader;

struct bmp_palette {
  guint8  b;
  guint8  g;
  guint8  r;
  guint8  reserved;
};
typedef struct bmp_palette BMPPalette;

static gint WriteBMPHeader( FILE *out );
static gint WriteBMP( FILE *out, guint8 *data );

gint WriteBMPFile( gchar *filename, guint8 *data )
{
  FILE *file;
  
  file = fopen( filename, "wb" );
  if( file == NULL ) {
    fprintf( stderr, "Can't Open File to write !!![%s]\n", filename );
    return -1;
  }
  
  WriteBMP( file, data );
  
  fclose( file );  
  return 0;
}

static gint WriteBMP( FILE *out, guint8 *data )
{
  gint  i;
  
  WriteBMPHeader( out );
  
  for( i=0;i<160;i++ ) {
    fwrite( data+(159-i)*20, 1, 20, out );
  }
  
  return 0;
}

static gint WriteBMPHeader( FILE *out )
{
  BMPHeader   h;
  BMPPalette  pl[2];
  
  /* fseek( out, 0, SEEK_SET ); */ /* Set FilePointer to Start */
  fputc( 'B', out );
  fputc( 'M', out );  /* Header */
  
  h.filesize = 2 + sizeof(BMPHeader) + sizeof(BMPPalette)*2 + 160*20;
  h.reserved1 = 0;
  h.data_offset = 2 + sizeof(BMPHeader) + sizeof(BMPPalette)*2;
  h.header_size = 0x28;
  h.width = 160;
  h.height = 160;
  h.planes = 1;
  h.bpp = 1;
  h.comp = 0;
  h.data_size = 160*20;
  h.H_Resolution = 0;
  h.V_Resolution = 0;
  h.color_num = 0;
  h.imp_col_num = 0;
  fwrite( &h, sizeof(BMPHeader), 1, out );
  pl[0].r = 255; pl[0].g = 255; pl[0].b = 255; pl[0].reserved = 0;
  pl[1].r = 0;   pl[1].g = 0;   pl[1].b = 0;   pl[1].reserved = 0;

  fwrite( pl, sizeof(BMPPalette), 2, out );
  
  return 0;
}
