#include <stdio.h>
#include <gtk/gtk.h>
#include "sphereview.h"

static void set_tooltip( GtkWidget *widget, const gchar *tips );

int main( int argn, char *argv[] )
{
  GtkWidget *button;
  GtkWidget *window;
  GtkWidget *box1,*box2,*box3;
  GtkWidget *pixview;
  
  gtk_set_locale();
  gtk_init( &argn, &argv );
  
  /******************************* window ***************/
  
  window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
  gtk_window_set_title( GTK_WINDOW(window), "SphereViewer" );
  gtk_window_set_policy( GTK_WINDOW(window), FALSE, FALSE, FALSE );
  
  gtk_signal_connect( GTK_OBJECT(window), "destroy",
		      GTK_SIGNAL_FUNC(gtk_main_quit), NULL );
  
  gtk_container_border_width( GTK_CONTAINER(window), 10 );
  
  gtk_widget_realize( window );
  
  /******************************* box ******************/

  box1 = gtk_hbox_new( FALSE, 0 );
  gtk_container_add( GTK_CONTAINER(window), box1 );
  
  box2 = gtk_vbox_new( FALSE, 2 );
  gtk_box_pack_end( GTK_BOX(box1), box2, FALSE, FALSE, 5 );
  
  /****************************** pixview ****************/
  pixview = spv_pixview( window );
  gtk_box_pack_start( GTK_BOX(box1), pixview, FALSE, FALSE, 5 );
  
  /****************************** exit button *************/
  button = exit_button( window );
  gtk_box_pack_end( GTK_BOX(box2), button, FALSE, FALSE, 0 );
  set_tooltip( button, "SphereViewerλޤ" );
  gtk_widget_show( button );
  
  /****************************** allow button ***********/
  
  box3 = gtk_hbox_new( FALSE, 2 );
  
  button = allow_button( window, 1 );
  gtk_box_pack_start( GTK_BOX(box3), button, FALSE, FALSE, 0 );
  set_tooltip( button, "åֹ椬礭ذưޤ" );
  gtk_widget_show( button );
  
  button = allow_button( window, 0 );
  gtk_box_pack_end( GTK_BOX(box3), button, FALSE, FALSE, 0 );
  set_tooltip( button, "åֹ椬ذưޤ" );
  gtk_widget_show( button );
  
  gtk_box_pack_end( GTK_BOX(box2), box3, FALSE, FALSE, 0 );
  gtk_widget_show( box3 );
  
  /****************************** open & save button *****/
  
  box3 = gtk_hbox_new( FALSE, 2 );
  
  button = opendb_button( window );
  gtk_box_pack_start( GTK_BOX(box3), button, FALSE, FALSE, 0 );
  set_tooltip( button, "SphereDB.pdbե򳫤ޤ" );
  gtk_widget_show( button );
  
  button = savebmp_button( window );
  gtk_box_pack_end( GTK_BOX(box3), button, FALSE, FALSE, 0 );
  set_tooltip( button, "ɽβBMPե¸ޤ" );
  gtk_widget_show( button );
  
  gtk_box_pack_end( GTK_BOX(box2), box3, FALSE, FALSE, 0 );
  gtk_widget_show( box3 );
  
  /*******************************************************/
  
  gtk_widget_show( pixview );
  gtk_widget_show( button );
  gtk_widget_show( box2 );
  gtk_widget_show( box1 );
  gtk_widget_show( window );
  
  gtk_main();
  
  return 0;
}

void set_tooltip( GtkWidget* w, const gchar* tip )
{
  GtkTooltips* t = gtk_tooltips_new();

  gtk_tooltips_set_tip (t, w, tip, NULL);
}
