#include <stdio.h>
#include <gtk/gtk.h>
#include "sphereview.h"

static GdkPixmap*  null_pix;
static GdkPixmap** pixs;
static gint        page;
static GtkWidget  *pixview;

GtkWidget* spv_pixview( GtkWidget *parent )
{
  null_pix = gdk_pixmap_new( parent->window,
			     160, 160, -1 );
  pixview = gtk_pixmap_new( null_pix, NULL );
  
  gdk_draw_rectangle( null_pix,
                      parent->style->white_gc,
                      TRUE,
                      0, 0, 160, 160 );
  
  pixs = NULL;
  page = -1;
  
  return pixview;
}

void spv_pixview_load_db( gchar *filename )
{
  GdkPixmap**  pt;
  
  pt = create_pix_from_db( pixview, filename );
  if( pt == NULL ) return;
  
  if( pixs != NULL ) { g_free( (gpointer)pixs ); }
  pixs = pt;
  page = 0;
  
  gtk_pixmap_set( GTK_PIXMAP(pixview), pixs[0], NULL );
}

void spv_page_translate( gint offset )
{
  if( pixs == NULL ) return;
  
  page += offset;
  if( page<0 ) page+=5;
  if( page>4 ) page-=5;
  
  gtk_pixmap_set( GTK_PIXMAP(pixview), pixs[page], NULL );
}

gint spv_get_page()
{
  return page;
}
